var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useState, useEffect, forwardRef } from "react";
import { useTranslation } from "react-i18next";
import { CircularProgress, Snackbar, Button, IconButton, Tab, Tabs, } from "@material-ui/core";
import { AddCircle, Fullscreen, FullscreenExit, Close, } from "@material-ui/icons";
import { useTheme } from "@material-ui/core/styles";
import PyEditor from "./PyEditor";
import AnimatedOutputBox from "./AnimatedOutputBox";
import { v4 as uuid } from "uuid";
import { EditorState, } from "../types";
import FeedbackForm from "./FeedbackForm";
import styled from "styled-components";
import { OverlayCenterWrapper } from "./Overlay";
import { useWorker } from "../hooks/useWorker";
import { parseTestCases } from "../services/test_parsing";
import EditorOutput from "./EditorOutput";
import TestOutput from "./TestOutput";
import SubmissionOutput from "./SubmissionOutput";
import Problems from "./Problems";
import { faExclamationCircle, faPlay, faStop, } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faCopy } from "@fortawesome/free-regular-svg-icons";
import SubmittingOutput from "./SubmittingOutput";
import useStyles from "../hooks/useStyles";
import AlertDialog from "./AlertDialog";
import useCachedFileEntries from "../hooks/useCachedFileEntries";
import { emptyFile, exampleFiles } from "../constants";
import WithBrowserIncompatibilityOverlay from "./WithBrowserIncompatibilityOverlay";
var StyledButton = styled(function (props) { return (React.createElement(Button, __assign({ variant: "contained" }, props))); })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  margin: 0.5em;\n"], ["\n  margin: 0.5em;\n"])));
var StyledTab = styled(function (_a) {
    var shortName = _a.shortName, handleCloseFile = _a.handleCloseFile, inExerciseFiles = _a.inExerciseFiles;
    return (React.createElement("span", null,
        shortName,
        inExerciseFiles || (React.createElement(IconButton, { onClick: function (e) {
                e.stopPropagation();
                handleCloseFile(shortName);
            }, size: "small", style: { float: "right" } },
            React.createElement(Close, null)))));
})(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: inline;\n  width: 100%;\n"], ["\n  display: inline;\n  width: 100%;\n"])));
var initialFiles = { value: [emptyFile], timestamp: -1 };
var AddButton = function (_a) {
    var className = _a.className, onClick = _a.onClick, children = _a.children;
    return (React.createElement(IconButton, { className: className, onClick: onClick, children: children, title: "New file" }));
};
var ProgrammingExercise = forwardRef(function (_a, ref) {
    var _b;
    var submitFeedback = _a.submitFeedback, submitProgrammingExercise = _a.submitProgrammingExercise, submitToPaste = _a.submitToPaste, cacheKey = _a.cacheKey, debug = _a.debug, exercise = _a.exercise, submitDisabled = _a.submitDisabled, solutionUrl = _a.solutionUrl, editorHeight = _a.editorHeight, outputHeight = _a.outputHeight, onCopy = _a.onCopy, onFullScreen = _a.onFullScreen, projectFiles = _a.projectFiles;
    if (projectFiles) {
        exercise.projectFiles = projectFiles;
    }
    var t = useTranslation()[0];
    var _c = useState([]), output = _c[0], setOutput = _c[1];
    var _d = useState(), testResults = _d[0], setTestResults = _d[1];
    var _e = useState(true), workerAvailable = _e[0], setWorkerAvailable = _e[1];
    var _f = useCachedFileEntries(cacheKey, initialFiles), files = _f[0], setFiles = _f[1], setFilesIfNewer = _f[2];
    var _g = useState(0), activeFile = _g[0], setActiveFile = _g[1];
    var _h = useState(false), openNotification = _h[0], setOpenNotification = _h[1];
    var _j = useState(), executionTimeoutTimer = _j[0], setExecutionTimeoutTimer = _j[1];
    var worker = useWorker({ debug: debug })[0];
    var outputBoxRef = React.createRef();
    var _k = useState(EditorState.Initializing), editorState = _k[0], setEditorState = _k[1];
    var classes = useStyles();
    var _l = useState(false), fullScreen = _l[0], setFullScreen = _l[1];
    var theme = useTheme();
    function handleRun(code) {
        if (workerAvailable) {
            setOutput([]);
            setTestResults(undefined);
            setWorkerAvailable(false);
            setEditorState(EditorState.WorkerInitializing);
            worker.postMessage({
                type: "run",
                msg: {
                    code: code !== null && code !== void 0 ? code : files[activeFile].content,
                    debug: debug,
                    files: files,
                },
            });
        }
        else {
            console.log("Worker is busy");
        }
    }
    var handleSubmit = function () {
        setEditorState(EditorState.Submitting);
        setTestResults(undefined);
    };
    var handleReset = function () {
        setFiles(exercise.projectFiles.map(function (x) { return (__assign(__assign({}, x), { content: x.originalContent })); }));
        setActiveFile(0);
        setOutput([]);
        setTestResults(undefined);
    };
    worker.setMessageListener(function (e) {
        var _a = e.data, type = _a.type, msg = _a.msg;
        switch (type) {
            case "print":
                if (editorState === EditorState.ExecutingCode) {
                    setOutput(output.concat({ id: uuid(), type: "output", text: msg }));
                }
                break;
            case "input_required":
                setEditorState(EditorState.WaitingInput);
                break;
            case "error":
                console.error(msg);
                setOutput(output.concat({
                    id: uuid(),
                    type: "error",
                    text: msg,
                    traceback: e.data.traceback,
                }));
                setWorkerAvailable(true);
                worker.recycle();
                break;
            case "ready":
                setWorkerAvailable(true);
                break;
            case "print_batch":
                if (editorState === EditorState.ExecutingCode) {
                    var prints_1 = msg.map(function (text) { return ({
                        id: uuid(),
                        type: "output",
                        text: text,
                    }); });
                    setOutput(function (prevState) { return prevState.concat(prints_1); });
                }
                break;
            case "print_done":
                console.log("done executing");
                setEditorState(function (previous) {
                    switch (previous) {
                        case EditorState.Testing:
                            if ((testResults === null || testResults === void 0 ? void 0 : testResults.allTestsPassed) && !submitDisabled) {
                                handleSubmit();
                            }
                            return EditorState.ShowTestResults;
                        default:
                            return EditorState.Idle;
                    }
                });
                worker.recycle();
                break;
            case "test_results": {
                var testCases = parseTestCases(msg);
                setOutput([]);
                setTestResults({
                    allTestsPassed: testCases.every(function (x) { return x.passed; }),
                    points: [],
                    testCases: testCases,
                });
                break;
            }
            case "start_run":
                setEditorState(EditorState.ExecutingCode);
                break;
            case "start_test":
                setEditorState(EditorState.Testing);
                break;
            case "update_files":
                setFiles(JSON.parse(msg));
        }
    });
    var sendInput = function (input) {
        if (editorState === EditorState.WaitingInput) {
            setEditorState(EditorState.ExecutingCode);
            setOutput(output.concat({ id: uuid(), type: "input", text: "".concat(input, "\n") }));
            worker.postMessage({ type: "input", msg: input });
        }
    };
    useEffect(function () {
        var _a, _b;
        setFilesIfNewer({
            value: exercise.projectFiles,
            timestamp: (_b = (_a = exercise.submissionDetails) === null || _a === void 0 ? void 0 : _a.createdAtMillis) !== null && _b !== void 0 ? _b : -1,
        });
    }, [
        exercise.projectFiles,
        (_b = exercise.submissionDetails) === null || _b === void 0 ? void 0 : _b.createdAtMillis,
        setFilesIfNewer,
    ]);
    useEffect(function () {
        debug && console.log(EditorState[editorState]);
        switch (editorState) {
            case EditorState.Submitting:
                submitProgrammingExercise(files).then(function (data) {
                    closeOutput();
                    setTestResults(data);
                    setOutput([]);
                    setEditorState(data.allTestsPassed
                        ? EditorState.ShowPassedFeedbackForm
                        : EditorState.ShowSubmissionResults);
                });
                break;
            case EditorState.ExecutingCode:
            case EditorState.Testing: {
                var msg_1 = t("infiniteLoopMessage");
                var timeout = setTimeout(function () {
                    setOutput([
                        {
                            id: uuid(),
                            type: "output",
                            text: msg_1,
                        },
                    ]);
                    stopWorker();
                }, 10000);
                setExecutionTimeoutTimer(timeout);
                break;
            }
            case EditorState.Idle:
            case EditorState.RunAborted:
            case EditorState.ShowTestResults:
            case EditorState.WaitingInput:
                if (executionTimeoutTimer) {
                    clearTimeout(executionTimeoutTimer);
                }
                break;
        }
    }, [editorState]);
    var stopWorker = function () {
        if (!workerAvailable) {
            worker.terminate();
        }
        worker.postMessage({ type: "stop" });
        setEditorState(EditorState.RunAborted);
        setWorkerAvailable(true);
    };
    var closeOutput = function () {
        var _a;
        stopWorker();
        (_a = outputBoxRef.current) === null || _a === void 0 ? void 0 : _a.close();
        setEditorState(EditorState.Idle);
        setOutput([]);
    };
    var handleCloseNotification = function (event, reason) {
        if (reason === "clickaway") {
            return;
        }
        setOpenNotification(false);
    };
    var handleAddFile = function () {
        var filename = window.prompt("Filename: ");
        if (!filename) {
            return;
        }
        if (files.map(function (f) { return f.shortName; }).includes(filename)) {
            window.alert("".concat(filename, " already exists!"));
            return;
        }
        var newIdx = files.length;
        setFiles(function (files) { return __spreadArray(__spreadArray([], files, true), [
            {
                fullName: filename,
                shortName: filename,
                originalContent: "",
                content: "",
            },
        ], false); });
        setActiveFile(newIdx);
    };
    var handleCloseFile = function (name) {
        if (window.confirm("Are you sure you want to delete ".concat(name, "?"))) {
            setActiveFile(0);
            setFiles(function (files) { return files.filter(function (x) { return x.shortName !== name; }); });
        }
    };
    var handleFileChange = function (e, value) {
        var idx = typeof value === "number"
            ? value
            : files.findIndex(function (x) { return x && x.shortName === value; });
        setActiveFile(idx);
    };
    var handleCopy = function () {
        if (onCopy) {
            onCopy(files[activeFile]);
        }
    };
    var mapStateToOutput = function () {
        switch (editorState) {
            case EditorState.ShowTestResults:
                return (React.createElement(TestOutput, { getPasteLink: function () { return submitToPaste(files); }, onClose: closeOutput, outputHeight: outputHeight, onSubmit: function () { return handleSubmit(); }, submitDisabled: submitDisabled, testResults: testResults !== null && testResults !== void 0 ? testResults : { points: [], testCases: [] } }));
            case EditorState.ShowPassedFeedbackForm:
            case EditorState.ShowSubmissionResults:
                return (React.createElement(SubmissionOutput, { onClose: closeOutput, onSubmit: function () { return handleSubmit(); }, testResults: testResults !== null && testResults !== void 0 ? testResults : { points: [], testCases: [] }, getPasteLink: function () { return submitToPaste(files); }, pasteDisabled: submitDisabled, outputHeight: outputHeight }));
            case EditorState.Submitting:
                return (React.createElement(SubmittingOutput, { onClose: closeOutput, getPasteLink: function () { return submitToPaste(files); }, pasteDisabled: true }));
            case EditorState.ShowProblems:
                return (React.createElement(Problems, { onClose: closeOutput, problems: exercise.templateIssues, outputHeight: outputHeight }));
            default:
                return (React.createElement(EditorOutput, { editorState: editorState, getPasteLink: function () { return submitToPaste(files); }, onClose: closeOutput, outputContent: output, outputHeight: outputHeight, pasteDisabled: submitDisabled, sendInput: sendInput }));
        }
    };
    var handleEditorValueChange = function (newContent) {
        if (!exercise.ready)
            return;
        setFiles(function (prev) {
            return prev.map(function (x, i) {
                return i !== activeFile ? x : __assign(__assign({}, x), { content: newContent });
            });
        });
    };
    var handleFullScreenChange = function (fullscreen) {
        if (onFullScreen) {
            setFullScreen(fullscreen);
            onFullScreen(fullscreen);
        }
    };
    var pyEditorButtonsDisabled = (editorState & (EditorState.WorkerActive | EditorState.Submitting)) === 0;
    return (React.createElement(WithBrowserIncompatibilityOverlay, null,
        editorState === EditorState.ShowPassedFeedbackForm && (React.createElement(FeedbackForm, { awardedPoints: testResults === null || testResults === void 0 ? void 0 : testResults.points, onSubmitFeedback: function (feedback) {
                setEditorState(EditorState.ShowSubmissionResults);
                if (testResults) {
                    submitFeedback(testResults, feedback);
                    feedback.length > 0 && setOpenNotification(true);
                }
            }, onClose: function () { return setEditorState(EditorState.ShowSubmissionResults); }, solutionUrl: testResults === null || testResults === void 0 ? void 0 : testResults.solutionUrl, feedbackQuestions: testResults === null || testResults === void 0 ? void 0 : testResults.feedbackQuestions })),
        React.createElement("style", null, "\n              .MuiTab-wrapper {\n                display: inline !important;\n              }\n            "),
        React.createElement(Tabs, { value: files[activeFile].shortName, onChange: handleFileChange, variant: "scrollable", scrollButtons: "on", "aria-label": "label", "data-cy": "select-file" },
            files.map(function (_a) {
                var shortName = _a.shortName;
                return (React.createElement(Tab, { key: shortName, value: shortName, label: React.createElement(StyledTab, { shortName: shortName, handleCloseFile: handleCloseFile, inExerciseFiles: exercise.projectFiles
                            .map(function (x) { return x.shortName; })
                            .includes(shortName) }), style: {
                        textTransform: "none",
                        paddingRight: 0,
                        color: theme.palette.text.primary,
                    } }));
            }),
            React.createElement(AddButton, { onClick: handleAddFile },
                React.createElement(AddCircle, null))),
        !exercise.ready && (React.createElement(OverlayCenterWrapper, null,
            React.createElement(CircularProgress, { thickness: 5, color: "inherit" }))),
        React.createElement(PyEditor, { editorValue: files[activeFile].content, setEditorValue: handleEditorValueChange, editorHeight: editorHeight, setIsEditorReady: function (isReady) {
                return setEditorState(isReady ? EditorState.Idle : EditorState.Initializing);
            }, ref: ref }),
        React.createElement("div", { style: { padding: "0.6em 0em" } },
            (editorState & EditorState.WorkerActive) === 0 ? (React.createElement(StyledButton, { onClick: function () { return handleRun(); }, className: classes.runButton, disabled: !(workerAvailable &&
                    pyEditorButtonsDisabled &&
                    files[activeFile].fullName.endsWith(".py")), "data-cy": "run-btn" },
                React.createElement(FontAwesomeIcon, { icon: faPlay }),
                React.createElement("span", { className: classes.whiteText }, t("runButtonText")))) : (React.createElement(StyledButton, { className: classes.stopButton, onClick: function () { return stopWorker(); }, "data-cy": "stop-btn" },
                React.createElement(FontAwesomeIcon, { icon: faStop }),
                React.createElement("span", { className: classes.whiteText }, t("stopButtonText")))),
            onCopy && (React.createElement(StyledButton, { onClick: handleCopy, disabled: !pyEditorButtonsDisabled, className: classes.testButton, "data-cy": "test-btn", title: "Copy the code to your comment" },
                React.createElement(FontAwesomeIcon, { icon: faCopy }),
                React.createElement("span", { style: { paddingLeft: "5px" } }, "Copy"))),
            React.createElement(AlertDialog, { resetExercise: handleReset }),
            solutionUrl && (React.createElement(StyledButton, { className: classes.normalButton, onClick: function () { return window.open(solutionUrl, "_blank"); } }, t("modelSolution"))),
            onFullScreen && (React.createElement(IconButton, { style: { float: "right" }, onClick: function () { return handleFullScreenChange(!fullScreen); } }, fullScreen ? React.createElement(FullscreenExit, null) : React.createElement(Fullscreen, null))),
            exercise.templateIssues.length > 0 && (React.createElement(StyledButton, { onClick: function () {
                    var _a;
                    setEditorState(EditorState.ShowProblems);
                    (_a = outputBoxRef.current) === null || _a === void 0 ? void 0 : _a.open();
                }, disabled: (editorState & EditorState.WorkerActive) > 0, className: classes.problemsButton, "data-cy": "problems-btn" },
                React.createElement(FontAwesomeIcon, { icon: faExclamationCircle }),
                React.createElement("span", { className: classes.whiteText }, "".concat(t("problemsTitle"), " (").concat(exercise.templateIssues.length, ")"))))),
        React.createElement(AnimatedOutputBox, { isRunning: (editorState & EditorState.WorkerActive) > 0, outputHeight: outputHeight, ref: outputBoxRef }, mapStateToOutput()),
        debug && (React.createElement("div", null,
            React.createElement("div", null,
                "EditorState: ",
                EditorState[editorState]),
            React.createElement("div", null,
                "Cache key: ",
                cacheKey || "undefined"),
            React.createElement("div", null,
                "Active file: ",
                files[activeFile].fullName))),
        React.createElement(Snackbar, { open: openNotification, autoHideDuration: 5000, onClose: handleCloseNotification, message: t("thankYouForFeedback"), anchorOrigin: { vertical: "bottom", horizontal: "center" }, key: "bottom-center" })));
});
ProgrammingExercise.defaultProps = {
    submitProgrammingExercise: function () {
        return Promise.resolve({ points: [], testCases: [] });
    },
    submitToPaste: function () { return Promise.resolve("default paste called"); },
    exercise: {
        details: undefined,
        projectFiles: exampleFiles,
        ready: true,
        reset: function () { return console.log("Called for exercise reset."); },
        templateIssues: [],
        updateDetails: function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, console.log("Called for exercise details update.")];
        }); }); },
        getTestProgram: function () { return 'print("Default test called.")'; },
    },
    dark: false,
};
export { ProgrammingExercise };
var templateObject_1, templateObject_2;
//# sourceMappingURL=ProgrammingExercise.js.map