import { Paper } from "@material-ui/core";
import React, { useState } from "react";
import { useTranslation } from "react-i18next";
import useStyles from "../hooks/useStyles";
import Help from "./Help";
import { OutputBox, OutputBody, OutputButton, OutputColor, OutputFooterWithPercentage, OutputHeader, } from "./OutputBox";
import ScrollBox from "./ScrollBox";
import TestResults from "./TestResults";
var TestOutput = function (_a) {
    var getPasteLink = _a.getPasteLink, onClose = _a.onClose, onSubmit = _a.onSubmit, outputHeight = _a.outputHeight, submitDisabled = _a.submitDisabled, testResults = _a.testResults;
    var t = useTranslation()[0];
    var _b = useState(false), showAllTests = _b[0], setShowAllTests = _b[1];
    var scrollBoxRef = React.createRef();
    var classes = useStyles();
    var percentage = Math.round((100 * testResults.testCases.filter(function (x) { return x.passed; }).length) /
        testResults.testCases.length);
    var SubmitButton = function () { return (React.createElement(OutputButton, { disabled: submitDisabled, label: t("button.submit"), onClick: onSubmit, dataCy: "submit-btn", className: classes.blueButton })); };
    return (React.createElement(OutputBox, null,
        React.createElement(OutputHeader, { title: t("testResults"), color: OutputColor.Gray },
            React.createElement(Help, { getPasteUrl: getPasteLink, pasteDisabled: submitDisabled }),
            React.createElement(OutputButton, { label: t("button.close"), onClick: onClose, dataCy: "close-btn" })),
        React.createElement(OutputBody, null,
            React.createElement(ScrollBox, { maxHeight: outputHeight, ref: scrollBoxRef },
                React.createElement(TestResults, { results: testResults, showAllTests: showAllTests }, testResults.allTestsPassed && (React.createElement(Paper, { className: classes.allTestsPassedPaper },
                    React.createElement("h2", null, t("allTestsPassed")),
                    React.createElement("p", null, t("rememberToSubmitToServer")),
                    React.createElement(SubmitButton, null)))))),
        React.createElement(OutputFooterWithPercentage, { color: OutputColor.Gray, percentage: percentage, showAll: showAllTests, setShowAll: setShowAllTests, showAllDisabled: testResults.testCases.length === 1 }, !testResults.allTestsPassed && React.createElement(SubmitButton, null))));
};
export default TestOutput;
//# sourceMappingURL=TestOutput.js.map