import { useState, useEffect } from "react";
var cachedScripts = [];
export default function useScript(src) {
    var _a = useState({
        loaded: false,
        error: false,
    }), state = _a[0], setState = _a[1];
    useEffect(function () {
        if (cachedScripts.includes(src)) {
            setState({
                loaded: true,
                error: false,
            });
        }
        else {
            cachedScripts.push(src);
            var script_1 = document.createElement("script");
            script_1.src = src;
            script_1.async = false;
            var onScriptLoad_1 = function () {
                setState({
                    loaded: true,
                    error: false,
                });
            };
            var onScriptError_1 = function () {
                var index = cachedScripts.indexOf(src);
                if (index >= 0)
                    cachedScripts.splice(index, 1);
                script_1.remove();
                setState({
                    loaded: true,
                    error: true,
                });
            };
            script_1.addEventListener("load", onScriptLoad_1);
            script_1.addEventListener("error", onScriptError_1);
            document.body.appendChild(script_1);
            return function () {
                script_1.removeEventListener("load", onScriptLoad_1);
                script_1.removeEventListener("error", onScriptError_1);
            };
        }
    }, [src]);
    return [state.loaded, state.error];
}
//# sourceMappingURL=useScript.js.map